import 'package:domain/generated/json/base/json_convert_content.dart';
import 'package:domain/entity/myposts_sale_rent_entity.dart';

MypostsSaleRentEntity $MypostsSaleRentEntityFromJson(Map<String, dynamic> json) {
  final MypostsSaleRentEntity mypostsSaleRentEntity = MypostsSaleRentEntity();
  final int? count = jsonConvert.convert<int>(json['count']);
  if (count != null) {
    mypostsSaleRentEntity.count = count;
  }
  final int? page = jsonConvert.convert<int>(json['page']);
  if (page != null) {
    mypostsSaleRentEntity.page = page;
  }
  final int? limit = jsonConvert.convert<int>(json['limit']);
  if (limit != null) {
    mypostsSaleRentEntity.limit = limit;
  }
  final int? countPage = jsonConvert.convert<int>(json['count_page']);
  if (countPage != null) {
    mypostsSaleRentEntity.countPage = countPage;
  }
  final List<MypostsSaleRentList>? list = (json['list'] as List<dynamic>?)?.map(
          (e) => jsonConvert.convert<MypostsSaleRentList>(e) as MypostsSaleRentList).toList();
  if (list != null) {
    mypostsSaleRentEntity.list = list;
  }
  return mypostsSaleRentEntity;
}

Map<String, dynamic> $MypostsSaleRentEntityToJson(MypostsSaleRentEntity entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['count'] = entity.count;
  data['page'] = entity.page;
  data['limit'] = entity.limit;
  data['count_page'] = entity.countPage;
  data['list'] = entity.list?.map((v) => v.toJson()).toList();
  return data;
}

extension MypostsSaleRentEntityExtension on MypostsSaleRentEntity {
  MypostsSaleRentEntity copyWith({
    int? count,
    int? page,
    int? limit,
    int? countPage,
    List<MypostsSaleRentList>? list,
  }) {
    return MypostsSaleRentEntity()
      ..count = count ?? this.count
      ..page = page ?? this.page
      ..limit = limit ?? this.limit
      ..countPage = countPage ?? this.countPage
      ..list = list ?? this.list;
  }
}

MypostsSaleRentList $MypostsSaleRentListFromJson(Map<String, dynamic> json) {
  final MypostsSaleRentList mypostsSaleRentList = MypostsSaleRentList();
  final int? id = jsonConvert.convert<int>(json['id']);
  if (id != null) {
    mypostsSaleRentList.id = id;
  }
  final String? title = jsonConvert.convert<String>(json['title']);
  if (title != null) {
    mypostsSaleRentList.title = title;
  }
  final int? price = jsonConvert.convert<int>(json['price']);
  if (price != null) {
    mypostsSaleRentList.price = price;
  }
  final List<String>? resources = (json['resources'] as List<dynamic>?)?.map(
          (e) => jsonConvert.convert<String>(e) as String).toList();
  if (resources != null) {
    mypostsSaleRentList.resources = resources;
  }
  final String? createdAt = jsonConvert.convert<String>(json['created_at']);
  if (createdAt != null) {
    mypostsSaleRentList.createdAt = createdAt;
  }
  final int? likesCount = jsonConvert.convert<int>(json['likes_count']);
  if (likesCount != null) {
    mypostsSaleRentList.likesCount = likesCount;
  }
  return mypostsSaleRentList;
}

Map<String, dynamic> $MypostsSaleRentListToJson(MypostsSaleRentList entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['title'] = entity.title;
  data['price'] = entity.price;
  data['resources'] = entity.resources;
  data['created_at'] = entity.createdAt;
  data['likes_count'] = entity.likesCount;
  return data;
}

extension MypostsSaleRentListExtension on MypostsSaleRentList {
  MypostsSaleRentList copyWith({
    int? id,
    String? title,
    int? price,
    List<String>? resources,
    String? createdAt,
    int? likesCount,
  }) {
    return MypostsSaleRentList()
      ..id = id ?? this.id
      ..title = title ?? this.title
      ..price = price ?? this.price
      ..resources = resources ?? this.resources
      ..createdAt = createdAt ?? this.createdAt
      ..likesCount = likesCount ?? this.likesCount;
  }
}